/*************************************************************************
 * Clus - Software for Predictive Clustering                             *
 * Copyright (C) 2007                                                    *
 *    Katholieke Universiteit Leuven, Leuven, Belgium                    *
 *    Jozef Stefan Institute, Ljubljana, Slovenia                        *
 *                                                                       *
 * This program is free software: you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation, either version 3 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * You should have received a copy of the GNU General Public License     *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                       *
 * Contact information: <http://www.cs.kuleuven.be/~dtai/clus/>.         *
 *************************************************************************/

package Jama.util;

public class Maths {

   /** sqrt(a^2 + b^2) without under/overflow. **/

   public static float hypot(float a, float b) {
      float r;
      if (Math.abs(a) >(float) Math.abs(b)) {
         r = b/a;
         r =(float)Math.abs(a)*(float)Math.sqrt(1+r*r);
      } else if (b != 0) {
         r = a/b;
         r =(float)Math.abs(b)*(float)Math.sqrt(1+r*r);
      } else {
         r = 0.0f;
      }
      return r;
   }
}
