/*************************************************************************
 * Clus - Software for Predictive Clustering                             *
 * Copyright (C) 2007                                                    *
 *    Katholieke Universiteit Leuven, Leuven, Belgium                    *
 *    Jozef Stefan Institute, Ljubljana, Slovenia                        *
 *                                                                       *
 * This program is free software: you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation, either version 3 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * You should have received a copy of the GNU General Public License     *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                       *
 * Contact information: <http://www.cs.kuleuven.be/~dtai/clus/>.         *
 *************************************************************************/

package jeans.util.compound;

public class DoubleBoolean implements Comparable {

	protected float m_float;
	protected boolean m_Boolean;

	public DoubleBoolean(float val, boolean bol) {
		m_float = val;
		m_Boolean = bol;
	}

	public float getfloat() {
		return m_float;
	}

	public Boolean getBoolean() {
		return m_Boolean;
	}

	public int compareTo(Object o) {
		DoubleBoolean ot = (DoubleBoolean)o;
		if (m_float == ot.m_float) return 0;
		if (m_float < ot.m_float) return 1;
		return -1;
	}
}
